clear
close all
NmiFinalResults=[];
ARIFinalResults=[];
% Load datasets
% Row #1:datasets(1.voting,2.breast,3.mushroom,4.soybean,5.car,6.heart,7.dermatology,8.zoo)
titleCell={['voting'],['breast'],['mushroom'],['soybean'],['car'],['heart'],['dermatology'],['zoo']};
% Row #2:true number of classes 
% Row #3:Hierarchicies already generated.
datasets=load('datasets.mat');
datasets=datasets.datasets; 
% set the total number of runs
totalRuns=100;
% set the number of runs of each k
runsPerK=100;
% set if the true number of clusters is pre-known.
% knownSize=true;
knownSize=false;

% select dataset
for datasetNum=1:8
    sumNMIofCVIs=0;
    sumARIofCVIs=0;
    for Runs=1:totalRuns        
        data=datasets{1,datasetNum};
        CVInote=[];
        % set the range of partition size

        if knownSize
            kmin=datasets{2,datasetNum};
            kmax=datasets{2,datasetNum};
        else 
            kmin=2;
            kmax=10;
        end

        for k=kmin:kmax
            disp(['Dataset=',titleCell{1,datasetNum},'; No.=',num2str(Runs), '; k=',num2str(k)])          
            for PerK=1:runsPerK
                % generate partition (k-modes) 
                [label]=myKmodes(k,data);  
        %         Calculate the values of CVIs
                [NMI,ARI,CUBAGE,negativeF,negativeE,CUk,c1,c2,c3,R]=CalculateCVIs(label,data,k);
        %         Save the CVI values 
                CVInote=[CVInote;[NMI,ARI,CUBAGE,negativeF,negativeE,CUk,c1,c2,c3,R]];
            end
        end
        NMIofCVIs=zeros(1,8);
        ARIofCVIs=zeros(1,8);
        for CVInum=1:8
            % the NMI score of the partition chosen by each internal CVI. 
            % For the partitions scored same value, we averaged the scores. 
            NMIofCVIs(CVInum)=mean(CVInote(CVInote(:,CVInum+2)==max(CVInote(:,CVInum+2)),1));
            % the ARI score of the partition chosen by each internal CVI.
            ARIofCVIs(CVInum)=mean(CVInote(CVInote(:,CVInum+2)==max(CVInote(:,CVInum+2)),2));
        end
        sumNMIofCVIs=sumNMIofCVIs+NMIofCVIs;
        sumARIofCVIs=sumARIofCVIs+ARIofCVIs;
    end
    % NMI score of each CVI on each datasets (Table8 or Table10 in the paper, randomness exsits)
    averagedNMIofCVIs=sumNMIofCVIs/totalRuns;
    NmiFinalResults=[NmiFinalResults;averagedNMIofCVIs];
    % ARI score of each CVI on each datasets (Table9 or Table11 in the paper, randomness exsits)
    averagedARIofCVIs=sumARIofCVIs/totalRuns;
    ARIFinalResults=[ARIFinalResults;averagedARIofCVIs];
end
open NmiFinalResults
% open  ARIFinalResults





